/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2007</p>
 * <p>Company: </p>
 * @author Ioannis Partalas, Grigorios Tsoumakas 
 * @version 24/07/2007
 */


import weka.classifiers.*;
import weka.classifiers.bayes.*;
import weka.classifiers.functions.*;
import weka.classifiers.lazy.*;
import weka.classifiers.meta.*;
import weka.classifiers.rules.*;
import weka.classifiers.trees.*;
import weka.classifiers.evaluation.*;
import weka.core.*;
import weka.core.converters.*;
import weka.experiment.*;
import weka.filters.*;
import weka.filters.unsupervised.attribute.*;
import java.io.*;
import java.util.*;
import weka.filters.supervised.instance.*;

//import wekatools.*;

public class pruning 
{
    public int M; // Number of the models

    public Instances PruningData;
    public Instances TestData;

    public Instances[] resultsrain;
    public Instances[] resultsPrune;
    public Instances[] resultsTest;

    public double[][] RMSvsENS;
    public double[][] tmpRMS;

    public int [] sumInternal;
    public double bmodelAcc=0.0;

    public pruning()
    {
	RMSvsENS = new double[200][2];
    }


    private int findBestModel()
    {
	ResultsDataset tmpRes;
	double bestAcc=-1*Double.MAX_VALUE;
	int bestModel=-1;
	double tacc=0.0;

	try{
	for(int i=0;i<M;i++)
	{
	    tmpRes = new ResultsDataset(resultsPrune[i]);
	    tacc = tmpRes.accuracy();

	    if(bestAcc < tacc)
	    {
		bestAcc = tacc;
		bestModel = i;
	    }
	}

	System.out.println(bestModel+" "+bestAcc);
	ResultsDataset testRes = new ResultsDataset(resultsTest[bestModel]);

	System.out.println(testRes.accuracy());
	bmodelAcc+=testRes.accuracy();

	}catch(Exception ex){ex.printStackTrace();}
	return bestModel;
    }

    private Instances LoadArff(String FileStem)
    {
	try {
	    ArffLoader aLoader = new ArffLoader();
	    FileInputStream aFile = new FileInputStream(FileStem);
	    aLoader.setSource(aFile);
	    Instances Data = new Instances(aLoader.getDataSet());
	    aFile.close();
	    return Data;
	}
	catch (Exception Ex) {
	    System.out.println(Ex);
	    System.out.println(FileStem);
	    return null;
	}
    }

    private ArrayList LoadModels(String path,String stem)
    {
	J48 model = new J48();
	ArrayList arrayModels= new ArrayList(M);
	Random rnd = new Random(System.currentTimeMillis());

	try
	{
	    for(int i=0;i<M;i++)
	    {
		model = new J48();
		ObjectInputStream ois = new ObjectInputStream(new FileInputStream(path+stem+i+".model"));
		model = (J48) ois.readObject();
		arrayModels.add((J48)model);
		ois.close();
	    }

	    ArrayList shuffled = new ArrayList();

	    while(arrayModels.size()>0)
	    {
		int ran = rnd.nextInt(arrayModels.size());
		model = new J48();
		model = (J48)arrayModels.remove(ran);
		shuffled.add(((J48)model));
	    }

	    return shuffled;
	}
	catch(Exception Ex)
	{
	    System.out.println("Failed to load models");
	    System.out.println(Ex);
	    return null;
	}

    }

    private double margin(ArrayList indexes, int index, double p)
    {
	ResultsDataset modelResults = new ResultsDataset(resultsPrune[index]);

	
	int size = indexes.size();
	if (size == 0)
	    return modelResults.accuracy();

//	ResultsDataset[] ensembleResults = new ResultsDataset[size];
//	for (int i=0; i<size; i++)
//	    ensembleResults[i] = new ResultsDataset(resultsPrune[Integer.parseInt(indexes.get(i).toString())]);

	int numInstances = modelResults.Data.numInstances();
	double sumExternal=0;
	for (int i=0; i<numInstances; i++)
	{
	    double modelVal;           
	    if (modelResults.classifyInstance(i) == modelResults.classValue(i))
		modelVal = 1;
	    else
		modelVal = -1;

	/*    double sumInternal=0;
	    for (int j=0; j<size; j++)
		if (ensembleResults[j].classifyInstance(i) == ensembleResults[j].classValue(i))
		    sumInternal += 1;
		else
		    sumInternal -= 1;*/

	    sumExternal += Math.pow((p - (sumInternal[i] + modelVal)/(double)size), 2.0); 
	}

	return Math.sqrt(sumExternal);
    }    

    private double averaging(ArrayList indexes, String Data)
    {
	if (Data.compareTo("prune") == 0)
	{
	    ResultsDataset rd = new ResultsDataset(resultsPrune[Integer.parseInt(indexes.get(0).toString())]);

	    int size = indexes.size();
	    for (int i=1; i<size; i++)
		rd.AddPredictions(resultsPrune[Integer.parseInt(indexes.get(i).toString())]);      
	    rd.DividePredictions(size);

	    return rd.accuracy();
	}
	if (Data.compareTo("test") == 0)
	{
	    ResultsDataset rd = new ResultsDataset(resultsTest[Integer.parseInt(indexes.get(0).toString())]);

	    int size = indexes.size();
	    for (int i=1; i<size; i++)
		rd.AddPredictions(resultsTest[Integer.parseInt(indexes.get(i).toString())]);      
	    rd.DividePredictions(size);

	    return rd.accuracy();
	}

	return -1;
    }


    private double complementariness(ResultsDataset ensembleResults, int index)
    {
	ResultsDataset modelResults = new ResultsDataset(resultsPrune[index]);

	if (ensembleResults.numModels == 0)
	    return modelResults.accuracy();

	ensembleResults.DividePredictions(ensembleResults.numModels);

	int numInstances = modelResults.Data.numInstances();
	double comp=0;
	for (int i=0; i<numInstances; i++)
	{
	    if (ensembleResults.classifyInstance(i) != ensembleResults.classValue(i))
		if (modelResults.classifyInstance(i) == modelResults.classValue(i))
		    comp += 1;
	}
	return comp;
    }


    private double weight_comp(ResultsDataset ensembleResults, int index)
    {
	//     int size = indexes.size();
	int numTrue = 0;

	ResultsDataset modelResults = new ResultsDataset(resultsPrune[index]);

	if (ensembleResults.numModels == 0)
	    return modelResults.accuracy();


	ensembleResults.DividePredictions(ensembleResults.numModels);

	int numInstances = modelResults.Data.numInstances();
	int T = ensembleResults.numModels;
	double a,b;

	double comp=0;
	for (int i=0; i<numInstances; i++)
	{
	    a=0;
	    b=0;

	    if ( ensembleResults.classifyInstance(i) != ensembleResults.classValue(i))
	    {
		if (modelResults.classifyInstance(i) == modelResults.classValue(i))
		    a = 1*((double)ensembleResults.numTrue[i]/(double)T);
	    }
	    else 
		if (modelResults.classifyInstance(i) != modelResults.classValue(i))
		    b = 1*((double)ensembleResults.numFalse[i]/(double)T);

	    comp+=(a-b);
	}
	return comp;
    }


    private double wh2(ResultsDataset ensembleResults, int index)
    {
	//     int size = indexes.size();
	int numTrue = 0;

	ResultsDataset modelResults = new ResultsDataset(resultsPrune[index]);

	if (ensembleResults.numModels == 0)
	    return modelResults.accuracy();


	ensembleResults.DividePredictions(ensembleResults.numModels);

	int numInstances = modelResults.Data.numInstances();
	int T = ensembleResults.numModels;
	double a,b,c,d;

	double comp=0;
	for (int i=0; i<numInstances; i++)
	{
	    a=0;
	    b=0;
	    c=0;
	    d=0;

	    if ( ensembleResults.classifyInstance(i) != ensembleResults.classValue(i))
	    {
		if (modelResults.classifyInstance(i) == modelResults.classValue(i))
		    a = 1*((double)ensembleResults.numTrue[i]);
		if (modelResults.classifyInstance(i) != modelResults.classValue(i))
		    d = 1*((double)ensembleResults.numTrue[i]);
	    }
	    if ( ensembleResults.classifyInstance(i) == ensembleResults.classValue(i))
	    {
		if (modelResults.classifyInstance(i) != modelResults.classValue(i))
		    b = 1*((double)ensembleResults.numFalse[i]);
		if (modelResults.classifyInstance(i) == modelResults.classValue(i))
		    c = 1*((double)ensembleResults.numFalse[i]);
	    }
	
	    
	    comp+=((a-b+c-d)/(double)T);
	}
	return comp;
    }





    private double concurrency(ResultsDataset ensembleResults, int index)
    {
	ResultsDataset modelResults = new ResultsDataset(resultsPrune[index]);

	if (ensembleResults.numModels == 0)
	    return modelResults.accuracy();

	ensembleResults.DividePredictions(ensembleResults.numModels);

	int numInstances = modelResults.Data.numInstances();
	double conc=0;
	for (int i=0; i<numInstances; i++)
	{
	    if (ensembleResults.classifyInstance(i) != ensembleResults.classValue(i))
		if (modelResults.classifyInstance(i) == modelResults.classValue(i))
		    conc += 2;
		else
		    conc -= 2;
	    else
		if (modelResults.classifyInstance(i) == modelResults.classValue(i))
		    conc += 1;       
	}
	return conc;
    }


    private double QLearning(ArrayList indexes, int idex, int mode)
    {
	if(mode==1) // Training mode
	{
	}
	else
	{
	}
	return 0.0;
    }

    private ArrayList BackwardElimination(ArrayList models, String path, String pruneData, int heuristic)
    {       
	ArrayList unusedModels = new ArrayList(0);
	ArrayList currentEnsemble = new ArrayList(models);
	ArrayList bestEnsemble = new ArrayList(models);

	ResultsDataset currentResults;
	ResultsDataset testResults;
	currentResults = new ResultsDataset(resultsPrune[0]);
	testResults = new ResultsDataset(resultsTest[0]);
	currentResults.ZeroPredictions();
	testResults.ZeroPredictions();

	int size = models.size();

	for (int i=0; i<size; i++)
	{
	    currentResults.AddPredictions(resultsPrune[Integer.parseInt(models.get(i).toString())]);
	    testResults.AddPredictions(resultsTest[Integer.parseInt(models.get(i).toString())]);
	}

	if(heuristic == 4) // Margin heuristic
	{
	    ResultsDataset[] ensembleResults = new ResultsDataset[size];
	    for (int i=0; i<size; i++)
		ensembleResults[i] = new ResultsDataset(resultsPrune[Integer.parseInt(models.get(i).toString())]);

	    int nins = ensembleResults[0].Data.numInstances();
	    sumInternal = new int[nins];
	    
	    for(int i=0;i<nins;i++)
	    {
		for (int j=0; j<size; j++)
		    if (ensembleResults[j].classifyInstance(i) == ensembleResults[j].classValue(i))
			sumInternal[i] += 1;
		    else
			sumInternal[i] -= 1;
	    }
	}
	tmpRMS[currentEnsemble.size()-1][0] = currentResults.accuracy();
	tmpRMS[currentEnsemble.size()-1][1] = testResults.accuracy();

	int bp=0;
	double avrg=0;
	int iterations = 0;
	int max_it = models.size();
	Random rnd = new Random(System.currentTimeMillis());

	double bestAcc=-1*Double.MAX_VALUE;
	try{
	    while(currentEnsemble.size() > 1)
	    {
		//System.out.println("size: " + currentEnsemble.size());
		double max=-1*Double.MAX_VALUE;
		int maxId=-1;
		for(int i=0; i<currentEnsemble.size(); i++)
		{                   
		    //System.out.println(i);
		    int modelIndex;
		    switch(heuristic)
		    {
			case 1: modelIndex = Integer.parseInt(currentEnsemble.get(i).toString());
				currentEnsemble.remove(i);
				ResultsDataset tempRes3 = new ResultsDataset(currentResults);
				tempRes3.RemovePredictions(resultsPrune[modelIndex]);
				avrg = tempRes3.accuracy();
				currentEnsemble.add(i,new Integer(modelIndex));                                
				//System.out.println(currentEnsemble.toString());
				//System.out.println("avg="+avrg);
				break;
			case 2: modelIndex = Integer.parseInt(currentEnsemble.get(i).toString());
				currentEnsemble.remove(i);
				ResultsDataset tempRes = new ResultsDataset(currentResults);
				tempRes.RemovePredictions(resultsPrune[modelIndex]);
				avrg = -1*complementariness(tempRes, modelIndex);
				currentEnsemble.add(i,new Integer(modelIndex));                                
				break;
			case 3: modelIndex = Integer.parseInt(currentEnsemble.get(i).toString());
				currentEnsemble.remove(i);
				ResultsDataset tempRes1 = new ResultsDataset(currentResults);
				tempRes1.RemovePredictions(resultsPrune[modelIndex]);
				avrg = -1*concurrency(tempRes1, modelIndex);
				currentEnsemble.add(i, new Integer(modelIndex));                                
				break;
			case 4: modelIndex = Integer.parseInt(currentEnsemble.get(i).toString());
				currentEnsemble.remove(i);
				ResultsDataset brd = new ResultsDataset(resultsPrune[modelIndex]);
				int [] tempSums = new int[sumInternal.length];
				tempSums = sumInternal.clone();
				int nmins = brd.Data.numInstances();
				for(int j=0;j<nmins;j++)
				    if(brd.classifyInstance(j) == brd.classValue(j))
					sumInternal[j]-=1;
				    else
					sumInternal[j]+=1;
				avrg = -1*margin(currentEnsemble, modelIndex, 0.25);
				currentEnsemble.add(i, new Integer(modelIndex));                                
				sumInternal = tempSums.clone();
				break;
			case 5: modelIndex = Integer.parseInt(currentEnsemble.get(i).toString());
				currentEnsemble.remove(i);
				ResultsDataset tempRes2 = new ResultsDataset(currentResults);
				tempRes2.RemovePredictions(resultsPrune[modelIndex]);
				avrg = -1*weight_comp(tempRes2,modelIndex);
				currentEnsemble.add(i,new Integer(modelIndex));
				break;
			case 6: modelIndex = Integer.parseInt(currentEnsemble.get(i).toString());
				currentEnsemble.remove(i);
				ResultsDataset tempRes4 = new ResultsDataset(currentResults);
				tempRes4.RemovePredictions(resultsPrune[modelIndex]);
				avrg = -1*wh2(tempRes4,modelIndex);
				currentEnsemble.add(i,new Integer(modelIndex));
				break;
			default: System.out.println("Wrong heuristic at backward elimination"); 
				 System.exit(0);
		    }
		    if (avrg >= max)
		    {
			max = avrg;
			maxId = i;
		    }
		}

		currentResults.RemovePredictions(resultsPrune[Integer.parseInt(currentEnsemble.get(maxId).toString())]);      
		
		if(heuristic == 4)
		{
		    ResultsDataset brd = new ResultsDataset(resultsPrune[Integer.parseInt(currentEnsemble.get(maxId).toString())]);
		    int nmins = brd.Data.numInstances();
		    for(int j=0;j<nmins;j++)
			if(brd.classifyInstance(j) == brd.classValue(j))
			    sumInternal[j]-=1;
			else
			    sumInternal[j]+=1;
		}	
		
		testResults.RemovePredictions(resultsTest[Integer.parseInt(currentEnsemble.get(maxId).toString())]);
		currentEnsemble.remove(maxId);
		ResultsDataset tempTest = new ResultsDataset(testResults);
		tempTest.DividePredictions(tempTest.numModels);
		double tmpAcc = currentResults.accuracy();
		double testAcc = tempTest.accuracy();


		tmpRMS[currentEnsemble.size()-1][0] = tmpAcc;
		tmpRMS[currentEnsemble.size()-1][1] = testAcc;



		if(tmpAcc > bestAcc)
		{
		    bestAcc = tmpAcc;
		    bestEnsemble = (ArrayList) currentEnsemble.clone();
		}

	    }
	} catch(Exception ex){ 
	    ex.printStackTrace();
	    System.out.println(ex);
	}
	for(int i=0;i<200;i++)
	    for(int j=0;j<2;j++)
		RMSvsENS[i][j] += tmpRMS[i][j];

	return bestEnsemble;
    }

    private ArrayList ForwardSelection(ArrayList models, String path, String pruneData, int heuristic)
    {       
	ResultsDataset currentResults;
	ResultsDataset testResults;
	currentResults = new ResultsDataset(resultsPrune[0]);
	testResults = new ResultsDataset(resultsTest[0]);
	currentResults.ZeroPredictions();
	testResults.ZeroPredictions();

	if(heuristic == 4)
	    sumInternal = new int[currentResults.Data.numInstances()];

	ArrayList currentEnsemble = new ArrayList(0);
	ArrayList bestEnsemble = new ArrayList(0);
	ArrayList unusedModels = new ArrayList(models);
	ArrayList tempEns;
	int bp=0;
	double avrg=-1*Double.MAX_VALUE;
	int iterations = 0;
	int max_it = models.size();
	Random rnd = new Random(System.currentTimeMillis());

	double bestAcc=-1*Double.MAX_VALUE;
	try{
	    while(unusedModels.size() > 0)
	    {
		//System.out.println("size: " + currentEnsemble.size());
		double max=-1*Double.MAX_VALUE;
		int maxId=-1;
		for(int i=0; i<unusedModels.size(); i++)
		{                   
		    //System.out.println(i);
		    switch(heuristic)
		    {
			case 1: currentEnsemble.add(unusedModels.get(i));
				//avrg = averaging(currentEnsemble, pruneData);
				ResultsDataset tempResults3 = new ResultsDataset(currentResults);
				tempResults3.AddPredictions(resultsPrune[Integer.parseInt(unusedModels.get(i).toString())]);      
				avrg = tempResults3.accuracy();
				//System.out.println(currentEnsemble.toString());
				//System.out.println("avg="+avrg);
				currentEnsemble.remove(currentEnsemble.size()-1);
				break;
			case 2: currentEnsemble.add(unusedModels.get(i));
				ResultsDataset tempResults = new ResultsDataset(currentResults);
				avrg = complementariness(tempResults,Integer.parseInt(unusedModels.get(i).toString()));
				currentEnsemble.remove(currentEnsemble.size()-1);
				break;
			case 3: currentEnsemble.add(unusedModels.get(i));
				ResultsDataset tempResults2 = new ResultsDataset(currentResults);
				avrg = concurrency(tempResults2,Integer.parseInt(unusedModels.get(i).toString()));
				currentEnsemble.remove(currentEnsemble.size()-1);
				break;
			case 4: avrg = -1*margin(currentEnsemble, Integer.parseInt(unusedModels.get(i).toString()), 0.25);
				break;
			case 5: currentEnsemble.add(unusedModels.get(i));
				ResultsDataset tempResults1 = new ResultsDataset(currentResults);
				avrg = weight_comp(tempResults1,Integer.parseInt(unusedModels.get(i).toString()));
				currentEnsemble.remove(currentEnsemble.size()-1);
				break;
			case 6: currentEnsemble.add(unusedModels.get(i));
				ResultsDataset tempResults4 = new ResultsDataset(currentResults);
				avrg = wh2(tempResults4,Integer.parseInt(unusedModels.get(i).toString()));
				currentEnsemble.remove(currentEnsemble.size()-1);
				break;

			default: System.out.println("Wrong heuristic at forward selection"); 
				 System.exit(0);
		    }
		    if (avrg > max)
		    {
			max = avrg;
			maxId = i;
		    }
		}

		currentEnsemble.add(unusedModels.get(maxId));
		//double tmpAcc = averaging(currentEnsemble, pruneData);	

		currentResults.AddPredictions(resultsPrune[Integer.parseInt(unusedModels.get(maxId).toString())]);      
		testResults.AddPredictions(resultsTest[Integer.parseInt(unusedModels.get(maxId).toString())]);
		ResultsDataset tempTest = new ResultsDataset(testResults);
		tempTest.DividePredictions(currentEnsemble.size());
		double tmpAcc = currentResults.accuracy();
		double testAcc = tempTest.accuracy();

		if(heuristic == 4)
		{
		    ResultsDataset brd = new ResultsDataset(resultsPrune[Integer.parseInt(unusedModels.get(maxId).toString())]);
		    int nins = brd.Data.numInstances();
		    for(int j=0;j<nins;j++)
			if(brd.classifyInstance(j) == brd.classValue(j))
			    sumInternal[j]+=1;
			else
			    sumInternal[j]-=1;
		}

		tmpRMS[currentEnsemble.size()-1][0] = tmpAcc;
		tmpRMS[currentEnsemble.size()-1][1] = testAcc;


		unusedModels.remove(unusedModels.get(maxId));
		//System.out.println(currentEnsemble.toString());
		//System.out.println(unusedModels.toString());

		if(tmpAcc > bestAcc)
		{
		    bestAcc = tmpAcc;
		    bestEnsemble = (ArrayList) currentEnsemble.clone();
		}

	    }
	} catch(Exception ex){ 
	    ex.printStackTrace();
	    System.out.println(ex);
	}

	for(int i=0;i<200;i++)
	    for(int j=0;j<2;j++)
		RMSvsENS[i][j] += tmpRMS[i][j];
	return bestEnsemble;
    }


    // pruneData {"train", "prune"}
    public void loadPredictions(int size, String path, String pruneData,int typeOfPruneData)
    {
	resultsPrune = new Instances[size];
	for (int i=0; i<size; i++)
	{
	    resultsPrune[i] = LoadArff(path + pruneData + i + ".pred");
	    resultsPrune[i].setClassIndex(resultsPrune[i].numAttributes()-1);
	}        
	resultsTest = new Instances[size];
	for (int i=0; i<size; i++)
	{
	    if(typeOfPruneData==2)
	    {
		resultsTest[i] = LoadArff(path + "test" + i + ".pred");
		resultsTest[i].setClassIndex(resultsPrune[i].numAttributes()-1);
	    }
	    else
	    {
		resultsTest[i] = LoadArff(path + "testB" + i + ".pred");
		resultsTest[i].setClassIndex(resultsPrune[i].numAttributes()-1);
	    }
	}                
    }

    public static void main(String[] args)
    {
	pruning pruning = new pruning();
	J48 [] j48Classifiers; 
	String dataset =null;
	String pathtoresults = null;
	String pathtopredictions=null;
	String direction=null;
	String pruneData=null;
	int heuristic=0;
	int pruneType=1;
	double iterations = 1.0;

	pruning.M = 200;
	dataset = args[0];
	pathtopredictions = args[1];
	pathtoresults = args[2];

	if(args[3].compareTo("forward")==0 || args[3].compareTo("backward")==0)
	    direction = args[3];
	else
	{
	    System.out.println("Wrong argument for selection method, possible values: (forward/backward)");
	    System.out.println("Usage: java dataset pathtopredictions pathtoresults direction pruneData heuristic");
	    System.exit(0);
	}

	if(args[4].compareTo("prune")==0 )
	{
	    pruneData = args[4];
	    pruneType = 1;
	}
	else if(args[4].compareTo("train")==0)
	{
	    pruneData = args[4];
	    pruneType = 2;
	}
	else
	{
	    System.out.println("Wrong argument for pruneData, possible values: (prune/train)");
	    System.out.println("Usage: java dataset pathtopredictions pathtoresults direction pruneData heuristic");
	    System.exit(0);
	}


	if(args[5].compareTo("comp")==0)
	    heuristic = 2;
	else if(args[5].compareTo("averaging")==0)
	    heuristic = 1;
	else if(args[5].compareTo("conc")==0)
	    heuristic = 3;
	else if(args[5].compareTo("margin")==0)
	    heuristic = 4;
	else if(args[5].compareTo("wcomp")==0)
	    heuristic = 5;
	else if(args[5].compareTo("wh2")==0)
	    heuristic = 6;
	else
	{
	    System.out.println("Wrong argument for heuristic, possible values: (comp/averaging/conc)");
	    System.out.println("Usage: java dataset pathtopredictions pathtoresults direction pruneData heuristic");
	    System.exit(0);
	}



	try
	{
	    File fd = new File(pathtopredictions+direction+"_"+pruneData+"_"+args[5]+"meanAcc.txt");
	    FileWriter fw1 = new FileWriter(fd);
	    File f = new File(pathtoresults+dataset+"_"+direction+"_"+pruneData+"_"+args[5]+".txt");
	    FileWriter fw = new FileWriter(f);

	    File fdb = new File(pathtopredictions+dataset+"_bestModelsAcc.txt");

	    double mean_acc = 0.0;
	    int mean_models = 0;
	    int []typeOfModels = new int[5];
	    System.out.println(args[3]+" "+args[4]+" "+args[0]+args[5]+"\n\n");
	    for(int expNum=1; expNum<2; expNum++)
	    {

		String path=null;
		path = pathtopredictions+"exp"+expNum+"/Predictions/";

		pruning.tmpRMS = new double[200][2];

		long start = System.currentTimeMillis();
		ArrayList fullEnsemble = new ArrayList();
		for (int modelIndex=0; modelIndex<200; modelIndex++)
		    fullEnsemble.add(new Integer(modelIndex));

		pruning.loadPredictions(fullEnsemble.size(), path, pruneData,pruneType);             


		ArrayList finalEnsemble = new ArrayList();              
		if(direction.compareTo("forward")==0)
		    finalEnsemble = pruning.ForwardSelection(fullEnsemble, path, pruneData, heuristic);
		else
		    finalEnsemble = pruning.BackwardElimination(fullEnsemble, path, pruneData, heuristic);

		double res = pruning.averaging(finalEnsemble, "test");

		mean_acc+=res;
		mean_models += finalEnsemble.size();
		long elapsedTimeMillis = System.currentTimeMillis() - start;
		double elapsedTimeMin = elapsedTimeMillis/60000.0;
		fw.write(expNum+";"+res+";"+finalEnsemble.size()+";"+elapsedTimeMin+"\n"); 
		System.out.println(expNum+";"+res+";"+finalEnsemble.size()+";"+elapsedTimeMin);
		// Uncomment the following line for heterogeneous models, in order to produce
		// results about the type of models that are selected
		/*		int sz = finalEnsemble.size();
				Object [] tmplist = new Object[sz];
				tmplist = finalEnsemble.toArray();
				for(int s=0;s<sz;s++)
				{
				int ind = (Integer)tmplist[s];
				if(ind<24)
				typeOfModels[0]+=1;
				else if(ind > 23 && ind <84)
				typeOfModels[1]+=1;
				else if(ind>83 && ind < 194)
				typeOfModels[2]+=1;
				else if(ind>193 && ind <196)
				typeOfModels[3]+=1;
				else
				typeOfModels[4]+=1;
				}
				System.out.println(finalEnsemble.toString());
				System.out.println(Arrays.toString(typeOfModels));*/
		if(!fdb.exists())
		    pruning.findBestModel();
	    }

	    System.out.println("Mean RES::: "+ mean_acc/iterations + "MEAN MODELS::::"+mean_models/iterations+"\n\n");
	    if(!fdb.exists())
	    {
		FileWriter fwb = new FileWriter(fdb);
		fwb.write("Best model accuracy::: "+pruning.bmodelAcc/iterations+"\n");
		fwb.close();
	    }
	    for(int i=0;i<200;i++)
	    {
		for(int j=0;j<2;j++)
		{
		    pruning.RMSvsENS[i][j] /= iterations;
		}
		int k = i+1;
		fw1.write(pruning.RMSvsENS[i][0]+" "+pruning.RMSvsENS[i][1]+" "+k+"\n");
	    }
	    fw1.close();
	    fw.close();
	}
	catch(Exception ex){System.out.println(ex);}
    }
}
